![]() |
VR-Forces 4.8 Class Documentation
|
DtRadarSignaturePropagatorDescriptor; descriptor for the DtRadarSignaturePropagator component. More...

Public Member Functions | |
| DtRadarSignaturePropagatorDescriptor (const DtString &name, DtReaderWriterRegistry *parentRegistry=NULL) | |
| real constructor More... | |
| DtRadarSignaturePropagatorDescriptor (const DtSymbolString &name, DtReaderWriterRegistry *parentRegistry=NULL) | |
| DtRadarSignaturePropagatorDescriptor (const DtRadarSignaturePropagatorDescriptor &orig, DtReaderWriterRegistry *parentRegistry=NULL) | |
| copy constructor More... | |
| DtRadarSignaturePropagatorDescriptor & | operator= (const DtRadarSignaturePropagatorDescriptor &orig) |
| assignment More... | |
| virtual | ~DtRadarSignaturePropagatorDescriptor () |
| virtual DtString | type () const |
| Returns the type of component this descriptor describes. More... | |
| virtual DtSignaturePropagatorDescriptor * | clone (DtReaderWriterRegistry *parentRegistry=NULL) const |
| virtual double | rainToAttenuationCoefficient () const |
| Accessor/mutator for myRainToAttenuationCoefficient. More... | |
| virtual void | setRainToAttenuationCoefficient (double val) |
Public Member Functions inherited from DtStandardPropagatorDescriptor | |
| DtStandardPropagatorDescriptor (const DtString &name, DtReaderWriterRegistry *parentRegistry=NULL) | |
| real constructor More... | |
| DtStandardPropagatorDescriptor (const DtSymbolString &name, DtReaderWriterRegistry *parentRegistry=NULL) | |
| DtStandardPropagatorDescriptor (const DtStandardPropagatorDescriptor &orig, DtReaderWriterRegistry *parentRegistry=NULL) | |
| copy constructor More... | |
| DtStandardPropagatorDescriptor & | operator= (const DtStandardPropagatorDescriptor &orig) |
| assignment More... | |
| virtual | ~DtStandardPropagatorDescriptor () |
| virtual bool | checkLineOfSight () const |
| Accessor/mutator for myCheckLineOfSight. More... | |
| virtual void | setCheckLineOfSight (bool yesNo) |
| virtual DtString | defaultFeatureLosQuery () const |
| Accessor/mutator for myDefaultFeatureLosQuery. More... | |
| virtual void | setDefaultFeatureLosQuery (const DtString &query) |
| virtual DtString | highAltitudeFeatureLosQuery () const |
| Accessor/mutator for myHighAltitudeFeatureLosQuery. More... | |
| virtual void | setHighAltitudeFeatureLosQuery (const DtString &query) |
Public Member Functions inherited from DtSignaturePropagatorDescriptor | |
| DtSignaturePropagatorDescriptor (const DtString &name, DtReaderWriterRegistry *parentRegistry=NULL) | |
| real constructor More... | |
| DtSignaturePropagatorDescriptor (const DtSymbolString &name, DtReaderWriterRegistry *parentRegistry=NULL) | |
| DtSignaturePropagatorDescriptor (const DtSignaturePropagatorDescriptor &orig, DtReaderWriterRegistry *parentRegistry=NULL) | |
| copy constructor More... | |
| DtSignaturePropagatorDescriptor & | operator= (const DtSignaturePropagatorDescriptor &orig) |
| assignment More... | |
| virtual | ~DtSignaturePropagatorDescriptor () |
| virtual void | putData (std::string &fp, int indentLevel=0) |
| Overrides base class putData to output our type. More... | |
| virtual DtlObjPtr | getData (DtlObjPtr args, const DtReaderWriter::SearchPaths &searchPaths, const DtVariableBindingsList &variableBindings) |
| getData is just used to get us past the type in the data stream, since it's not actually stored. More... | |
| virtual bool | init () |
| Base class init does nothing, but will be called by createSignaturePropagatorDescriptor(), allowing derived classes to do memory allocation if necessary. More... | |
| virtual void | setPropagatorType (const DtString &componentType) |
| Accessor/mutator for myPropagatorType. More... | |
| virtual DtString | propagatorType () const |
Public Member Functions inherited from DtReaderWriter | |
| DtReaderWriter () | |
| default constructor More... | |
| DtReaderWriter (const DtString &name, DtReaderWriterRegistry *parentRegistry=NULL, bool readonly=false) | |
| real constructor Setting the readonly flag prevents object from writing itself to the stream. More... | |
| DtReaderWriter (const DtSymbolString &name, DtReaderWriterRegistry *parentRegistry=NULL, bool readonly=false) | |
| DtReaderWriter (const DtString &name, const DtReaderWriter &orig, DtReaderWriterRegistry *parentRegistry=NULL) | |
| pseudo-copy constructor More... | |
| DtReaderWriter (const DtSymbolString &name, const DtReaderWriter &orig, DtReaderWriterRegistry *parentRegistry=NULL) | |
| DtReaderWriter (const DtReaderWriter &, DtReaderWriterRegistry *parentRegistry=NULL) | |
| copy constructor More... | |
| const DtReaderWriter & | operator= (const DtReaderWriter &orig) |
| assignment operator More... | |
| bool | operator== (const DtReaderWriter &) const |
| Equivalence operator. More... | |
| bool | operator!= (const DtReaderWriter &rhs) |
| virtual | ~DtReaderWriter () |
| destructor More... | |
| virtual void | putSelf (std::string &fp, int indentLevel=0, bool writeUnspecified=false, const DtFilename &path=DtFilename::nullFilename()) |
| Top level call to write itself to file. More... | |
| virtual void | postPutSelf () |
| Called after either version of put self (file or environment). Default is no-op. More... | |
| virtual void | prePutSelf () |
| Called before either version of put self (file or environment). Default is no-op. More... | |
| virtual void | getSelf (DtlObjPtr args, const DtReaderWriter::SearchPaths &searchPaths=SearchPaths(), const DtVariableBindingsList &variableBindings=nullVariableReference()) |
| Top level to read itself from an input stream. More... | |
| virtual void | postGetSelf () |
| Called after either version of getSelf (mtl or environment). Default is no-op. More... | |
| virtual void | preGetSelf () |
| Called before either version of get self (file or environment). Default is no-op. More... | |
| virtual void | writeSelf (std::string &fp, int indentLevel=0, bool writeUnspecified=false, const DtFilename &path=DtFilename::nullFilename()) |
| Called from putSelf, calls myRegistry.putSelf which in turn calls putSelf on each reader/writer in the registry. More... | |
| virtual DtSymbolString | name () const |
| Accessor for name of this readable/writable object. More... | |
| virtual void | addAlias (const DtSymbolString &alias) |
| Add an alias as an alternative name for this object. More... | |
| virtual void | addAlias (const DtString &alias) |
| virtual bool | hasAlias (const DtSymbolString &alias) |
| virtual const aliasContainer & | aliases () const |
| virtual void | setReadonly (bool flag) |
| Set read-only flag. More... | |
| bool | isReadonly () const |
| virtual void | reset () |
| For those reader/writer items that support it, resets the reader/writer value to original state Default is no-op. More... | |
| virtual int | alignment () const |
| For those items that are sent over the network via HLA, this will give the network alignment. More... | |
| virtual bool | variableIsBound () const |
| virtual void | unbindVariable () |
| Sets the myVariableIsBound flag to false. More... | |
| virtual void | setName (const DtString &) |
| Set the name of the object. More... | |
| virtual const char * | readerWriterType () const |
| Used to supply a string type that this reader writer type is. More... | |
| virtual const char * | xmlType () const |
| virtual DtString | prettyPrint () const |
| Routine to return a human readable form of the reader/writer variable. More... | |
| std::string | debugText () const |
| virtual void | bindVariables (DtVariableBindingsList variableBindings) |
| Runs a variable binding pass on this reader writer and any of its children. More... | |
| virtual std::list < DtVariableNameType > | unboundVariables () const |
| bool | invalid () const |
| virtual bool | hasChild (const DtReaderWriter *p) const |
| Returns true if this variable has a child p in it's chain. More... | |
| virtual bool | hasVariableReference () const |
| Returns true if this item or any item in the registry (recursive) is a variable reference. More... | |
| virtual void | bindLocalVariables (const DtVariableBindingsList &variableBindings) |
| Checks to see if this RW object is a variable reference that can be bound using the provided bindings. More... | |
| virtual void | recordUpdateTime () const |
| Can be implemented in subclasses to stamp the time when updated. More... | |
| virtual bool | wasUpdatedSince (DtTime t) const |
| Can be implemented in subclasses to return true if an update occurred after the specified time. More... | |
| virtual bool | changedSinceLastChecked () |
| Returns true if this objects value has changed since the last time this function was called. More... | |
| virtual bool | peekChangedSinceLastChecked () const |
| Returns the value that changedSinceLastChecked would return but does not reset the internal flag. More... | |
| virtual void | setValueSpecified (bool specified, bool recurse=false) |
| The specified flags are used for optional values. More... | |
| virtual bool | valueSpecified () const |
| virtual bool | isVariableReference () const |
| Specifies whether or not this reader writer is really a variable that is specified elsewhere. More... | |
| virtual void | setIsVariableReference (bool value) |
| virtual void | clearAllVariableReferenceFlags () |
| Clears out all variable reference flags from all readerwriter items in registry recursively. More... | |
| virtual DtSymbolString | variableName () const |
| The variable name, if this object is a variable reference. More... | |
| virtual void | setVariableName (const DtSymbolString variableName) |
| virtual const DtReaderWriter * | defaultRWValue () const |
| The default value to use if the reader/writer object is a variable and that variable is not specified. More... | |
| virtual DtReaderWriter * | defaultRWValue () |
| virtual void | setDefaultRWValue (DtReaderWriter *) |
| Previous default value, if exists, will be removed and replaced with a clone of the supplied variable. More... | |
| virtual bool | checkAndSetDefaultRWValue (DtlObjPtr args, const DtReaderWriter::SearchPaths &searchPaths=SearchPaths(), const DtVariableBindingsList &variableBindings=nullVariableReference()) |
| Give the stream, if the stream contains a default value then set it here. More... | |
| const DtReaderWriterRegistry & | registry () const |
| Collection of child DtReaderWriter nodes owned by this object. More... | |
| DtReaderWriterRegistry & | registry () |
| virtual DtPropertyInterface * | property () |
| virtual const DtPropertyInterface * | property () const |
| virtual DtString | toXml () const |
| virtual DtRwVariableBindings * | generateVariableBindings () const |
| Iterates over the registry (recursively) and returns a variable bindings object that contains all the variables that are contained in this read/writer class. More... | |
| virtual bool | toXml (const DtFilename &) const |
| Writes contents of xml result to the given filename. More... | |
| virtual bool | fromXml (const DtString &) |
| Restores object from given xml string. Returns true if valid. More... | |
| virtual bool | fromXmlFile (const DtFilename &) |
| Restores object from given xml file. More... | |
| virtual void | putSelf (DtEnvironmentSP, DtEnvValueSP parent) const |
| virtual void | putData (DtEnvironmentSP, DtEnvValueSP value) const |
| Override to add attributes of actual data. More... | |
| virtual void | putVariableReference (DtEnvironmentSP, DtEnvValueSP value) const |
| Called when the item is a variable reference. More... | |
| virtual void | getSelf (const DtEnvironmentSP, const DtEnvValueSP root, const SearchPaths &searchPaths=SearchPaths(), const DtVariableBindingsList &bindings=DtVariableBindingsList()) |
| virtual void | getData (const DtEnvironmentSP, const DtEnvValueSP, const SearchPaths &searchPaths=SearchPaths(), const DtVariableBindingsList &bindings=DtVariableBindingsList()) |
| Gets data from the environment value. More... | |
| virtual void | unrecognizedItem (const DtEnvironmentSP env, const DtEnvValueSP root, const SearchPaths &searchPaths, const DtVariableBindingsList &varBindings) |
| Called when the xml reader tries to parse an unknown reader/writer item. Default is a no-op. More... | |
| virtual void | getVariableReference (DtEnvironmentSP, DtEnvValueSP value) |
| Called when the item is a variable reference. More... | |
Static Public Member Functions | |
| static DtSignaturePropagatorDescriptor * | creator () |
Static Public Member Functions inherited from DtStandardPropagatorDescriptor | |
| static DtSignaturePropagatorDescriptor * | creator () |
Static Public Member Functions inherited from DtSignaturePropagatorDescriptor | |
| static DtSignaturePropagatorDescriptorFactory * | factory () |
| Factory used to generate new instances of DtSignaturePropagatorDescriptor objects, based on the types defined in signaturePropagatorDescTypes.h. More... | |
| static void | setFactory (DtSignaturePropagatorDescriptorFactory *factory) |
| static DtSignaturePropagatorDescriptor * | createSignaturePropagatorDescriptor (DtlObjPtr mtlStream, const DtReaderWriter::SearchPaths &searchPaths, const DtVariableBindingsList &variableBindings) |
| static DtSignaturePropagatorDescriptor * | createSignaturePropagatorDescriptor (const char *pName) |
| static DtSignaturePropagatorDescriptor * | creator () |
Static Public Member Functions inherited from DtReaderWriter | |
| static void | putIndent (std::string &fp, int indentLevel) |
| static const DtVariableBindingsList & | nullVariableReference () |
| static void | setPostGetSelfCallback (DtGetSelfCallbackFcn fcn, void *usrData) |
| static void | setPrePutSelfCallback (DtPutSelfCallbackFcn fcn, void *usrData) |
| static void | setPutIndent (bool) |
| static bool | putIndent () |
| static const char * | theXmlType () |
| The type that is used when archiving to an XML stream. More... | |
| static const DtFilename & | appPath () |
| Gets the current working directory. More... | |
| static void | setFactoryCreatorFunction (DtReaderWriterFactoryCreatorFcn fcn) |
| Sets the function to create the DtReaderWriterFactory. More... | |
| static void | createReaderWriterFactory () |
| static void | cleanupFactory () |
| static DtReaderWriterFactory * | factory () |
| static void | setOutputStream (DtOutputStream *stream) |
| static DtOutputStream & | outputStream () |
| static DtReaderWriter * | createFromXmlFile (const DtFilename &, bool createAsProperty=false) |
| Given a filename, returns a newly created reader/writer object from the object found within. More... | |
| static DtReaderWriter * | createFromXml (const DtString &, bool createAsProperty=false) |
| Given a xml string, returns a newly created reader/writer object from the object found within. More... | |
| static DtReaderWriter * | createFromEnvironment (DtEnvironmentSP, bool createAsProperty=false) |
| Given a xml environment, returns a newly created reader/writer object from the object found within. More... | |
| static DtString | getAttribute (DtEnvironmentSP env, const DtString &name, DtEnvValueSP root) |
| Gets the named attribute from a DtEnvValueSP. More... | |
Protected Attributes | |
parameters | |
These parameters are available for setting in the OPD files. | |
| DtRwReal | myRainToAttenuationCoefficient |
| Parameter Name: rain-to-attenuation-coefficient Parameter Description: This value is multiplied by the rain intensity in mm/h to determine the attenuation coefficient due to rain. More... | |
Protected Attributes inherited from DtStandardPropagatorDescriptor | |
| DtRwBoolean | myCheckLineOfSight |
| Parameter Name: check-line-of-sight Parameter Description: Flag indicating whether or not a line-of-sight check should be performed. More... | |
| DtRwString | myDefaultFeatureLosQuery |
| Parameter Name: default-feature-los-query Parameter Description: The default Los query to used. More... | |
| DtRwString | myHighAltitudeFeatureLosQuery |
| Parameter Name: high-altitude-feature-los-query Parameter Description: The Los query to used when both entities are high above the terrain. More... | |
Protected Attributes inherited from DtSignaturePropagatorDescriptor | |
| DtRwString | myPropagatorType |
| Parameter Name: propagator-type Parameter Description: String identifying type of signature propagator object. More... | |
Protected Attributes inherited from DtReaderWriter | |
| const DtSymbolString | myName |
| DtReaderWriterRegistry | myRegistry |
| DtReaderWriterRegistry * | myParentRegistry |
| bool | myValueSpecified |
| bool | myReadOnlyFlag |
| bool | myIsVariableReference |
| DtSymbolString | myVariableName |
| bool | myVariableIsBound |
| DtReaderWriter * | myDefaultValue |
| aliasContainer | myAliases |
| Container for the aliases which represent alternative names for the object. More... | |
| bool | myInvalid |
| Set to true if there is a problem reading this item. More... | |
| bool | myChangedFlag |
| Set to true when value changes Set to false when value checked with changedSinceLastChecked. More... | |
Private Member Functions | |
| DtRadarSignaturePropagatorDescriptor () | |
| default constructor; not implemented More... | |
DtRadarSignaturePropagatorDescriptor; descriptor for the DtRadarSignaturePropagator component.
Descriptor containing configuration parameters for the DtRadarSignaturePropagator class.
| DtRadarSignaturePropagatorDescriptor::DtRadarSignaturePropagatorDescriptor | ( | const DtString & | name, |
| DtReaderWriterRegistry * | parentRegistry = NULL |
||
| ) |
real constructor
| DtRadarSignaturePropagatorDescriptor::DtRadarSignaturePropagatorDescriptor | ( | const DtSymbolString & | name, |
| DtReaderWriterRegistry * | parentRegistry = NULL |
||
| ) |
| DtRadarSignaturePropagatorDescriptor::DtRadarSignaturePropagatorDescriptor | ( | const DtRadarSignaturePropagatorDescriptor & | orig, |
| DtReaderWriterRegistry * | parentRegistry = NULL |
||
| ) |
copy constructor
|
virtual |
|
private |
default constructor; not implemented
| DtRadarSignaturePropagatorDescriptor& DtRadarSignaturePropagatorDescriptor::operator= | ( | const DtRadarSignaturePropagatorDescriptor & | orig | ) |
assignment
|
virtual |
Returns the type of component this descriptor describes.
Used to create the descriptor on read from an mtl file. Component descriptor type strings are defined in compDescTypes.h.
Reimplemented from DtStandardPropagatorDescriptor.
|
virtual |
Reimplemented from DtStandardPropagatorDescriptor.
|
static |
|
virtual |
Accessor/mutator for myRainToAttenuationCoefficient.
|
virtual |
|
protected |
Parameter Name: rain-to-attenuation-coefficient
Parameter Description: This value is multiplied by the rain intensity in mm/h to determine the attenuation coefficient due to rain.
Parameter Units: n/a Parameter Default Value: 0.05